package geniusweb.domaineditor;

import java.awt.BorderLayout;
import java.util.Collections;

import javax.swing.JFrame;

import org.junit.Test;

import geniusweb.domaineditor.model.DiscreteValueSetModel;
import geniusweb.domaineditor.model.DomainModel;
import geniusweb.domaineditor.model.ValueSetModel;
import geniusweb.domaineditor.panels.DomainEditorPanel;
import tudelft.utilities.listener.Listener;
import tudelft.utilities.logging.Reporter;
import tudelft.utilities.mvc.model.DefaultMapModel;
import tudelft.utilities.mvc.model.StringModel;
import tudelft.utilities.mvc.model.events.Event;
import tudelft.utilities.mvc.panels.PopupReporter;

public class DomainEditorPanelTest {
	private int n = 1;

	@Test
	public void GuiTest() throws InterruptedException {
		JFrame f = new JFrame();
		Reporter log = new PopupReporter(f);
		f.setLayout(new BorderLayout());

		StringModel namemodel = new StringModel("issue1", log);
		ValueSetModel valuesmmodel = new DiscreteValueSetModel(log);
		DefaultMapModel<StringModel, ValueSetModel> issuesmodel = new DefaultMapModel<StringModel, ValueSetModel>(
				Collections.singletonMap(namemodel, valuesmmodel), log) {

			@Override
			public String getColumnName(int n) {
				return n == 0 ? "issue" : "value";
			}

			@Override
			public ValueSetModel create(StringModel key) {
				// CALLER SHOULD ADD THIS TO ISSUE n++
				return new DiscreteValueSetModel(log);
			}

			@Override
			public int getMinimumSize() {
				return 1;
			}

		};
		DomainModel model = new DomainModel(new StringModel("testdomain", log),
				issuesmodel, log);
		model.addListener(new Listener<Event>() {

			@Override
			public void notifyChange(Event data) {
				System.out.println("String changed : " + data);
			}
		});
		f.getContentPane().add(new DomainEditorPanel(model, log),
				BorderLayout.CENTER);
		f.pack();
		f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		f.setVisible(true);
		Thread.sleep(10000);
		f.setVisible(false);
	}
}
